# ApplicationFramework
TKCAF
TFunction

# TFunction_Scope Class Reference

Keeps a scope of functions.
.

`#include <TFunction_Scope.hxx>`

Inheritance diagram for TFunction_Scope:

[legend]

## Public Member Functions

Standard_EXPORT | TFunction_Scope ()
Standard_EXPORT Standard_Boolean | AddFunction (const TDF_Label &L)
| Adds a function to the scope of functions. .
Standard_EXPORT Standard_Boolean | RemoveFunction (const TDF_Label &L)
| Removes a function from the scope of functions. .
Standard_EXPORT Standard_Boolean | RemoveFunction (const Standard_Integer ID)
| Removes a function from the scope of functions. .
Standard_EXPORT void | RemoveAllFunctions ()
| Removes all functions from the scope of functions. .
Standard_EXPORT Standard_Boolean | HasFunction (const Standard_Integer ID) const
| Returns true if the function exists with such an ID. .
Standard_EXPORT Standard_Boolean | HasFunction (const TDF_Label &L) const
| Returns true if the label contains a function of this scope. .
Standard_EXPORT Standard_Integer | GetFunction (const TDF_Label &L) const
| Returns an ID of the function. .
Standard_EXPORT const TDF_Label & | GetFunction (const Standard_Integer ID) const
| Returns the label of the function with this ID. .
Standard_EXPORT TFunction_Logbook & | GetLogbook ()
| Returns the Logbook used in TFunction_Driver methods. //! Implementation of Attribute methods =================================== .
Standard_EXPORT const Standard_GUID & | ID () const
| Returns the ID of the attribute. .
virtual Standard_EXPORT void | Restore (const Handle(TDF_Attribute)&with)
| Restores the backuped contents from <anattribute> into this one. It is used when aborting a transaction. .
virtual Standard_EXPORT void | Paste (const Handle(TDF_Attribute)&into, const Handle(TDF_RelocationTable)&RT) const

This method is different from the "Copy" one,
because it is used when copying an attribute from
a source structure into a target structure. This
method may paste the contents of <me> into
<intoattribute>.
The given pasted attribute can be full or empty of
its contents. But don't make a NEW! Just set the
contents!
It is possible to use <arelocationtable> to
get/set the relocation value of a source
attribute.
.

virtual Standard_EXPORT Handle_TDF_Attribute | NewEmpty () const
| Returns an new empty attribute from the good end type. It is used by the copy algorithm. .
virtual Standard_EXPORT Standard_OStream & | Dump (Standard_OStream &anOS) const
| Dumps the minimum information about <me> on <astream>. .
Standard_EXPORT const TFunction_DoubleMapOfIntegerLabel & | GetFunctions () const
| Returns the scope of functions. .
Standard_EXPORT TFunction_DoubleMapOfIntegerLabel & | ChangeFunctions ()
| Returns the scope of functions for modification. Warning: Don't use this method if You are not sure what You do! .
Standard_EXPORT void | SetFreeID (const Standard_Integer ID)
Standard_EXPORT Standard_Integer | GetFreeID () const
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT Handle_TFunction_Scope | Set (const TDF_Label &Access)
| Static methods ============== //! Finds or Creates a TFunction_Scope attribute at the root label accessed by <access>. Returns the attribute. .
static Standard_EXPORT const Standard_GUID & | GetID ()
| Returns the GUID for Scope attribute. //! Instant methods =============== //! Constructor (empty). .

## Private Attributes

TFunction_DoubleMapOfIntegerLabel | myFunctions
TFunction_Logbook | myLogbook
Standard_Integer | myFreeID

## Constructor & Destructor Documentation

Standard_EXPORT TFunction_Scope::TFunction_Scope | ( |  | ) |

## Member Function Documentation

Standard_EXPORT Standard_Boolean TFunction_Scope::AddFunction | ( | const TDF_Label & | L | ) |

Standard_EXPORT TFunction_DoubleMapOfIntegerLabel& TFunction_Scope::ChangeFunctions | ( |  | ) |

virtual Standard_EXPORT Standard_OStream& TFunction_Scope::Dump | ( | Standard_OStream & | anOS | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

Standard_EXPORT Standard_Integer TFunction_Scope::GetFreeID | ( |  | ) | const

Standard_EXPORT const TDF_Label& TFunction_Scope::GetFunction | ( | const Standard_Integer | ID | ) | const

Standard_EXPORT Standard_Integer TFunction_Scope::GetFunction | ( | const TDF_Label & | L | ) | const

Standard_EXPORT const TFunction_DoubleMapOfIntegerLabel& TFunction_Scope::GetFunctions | ( |  | ) | const

static Standard_EXPORT const Standard_GUID& TFunction_Scope::GetID | ( |  | ) | `[static]`

Standard_EXPORT TFunction_Logbook& TFunction_Scope::GetLogbook | ( |  | ) |

Standard_EXPORT const TFunction_Scope::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from TDF_Attribute.

Standard_EXPORT Standard_Boolean TFunction_Scope::HasFunction | ( | const TDF_Label & | L | ) | const

Standard_EXPORT Standard_Boolean TFunction_Scope::HasFunction | ( | const Standard_Integer | ID | ) | const

Standard_EXPORT const Standard_GUID& TFunction_Scope::ID | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

virtual Standard_EXPORT Handle_TDF_Attribute TFunction_Scope::NewEmpty | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

virtual Standard_EXPORT void TFunction_Scope::Paste | ( | const Handle(TDF_Attribute)& | into,
|  | const Handle(TDF_RelocationTable)& | RT
| ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TFunction_Scope::RemoveAllFunctions | ( |  | ) |

Standard_EXPORT Standard_Boolean TFunction_Scope::RemoveFunction | ( | const Standard_Integer | ID | ) |

Standard_EXPORT Standard_Boolean TFunction_Scope::RemoveFunction | ( | const TDF_Label & | L | ) |

virtual Standard_EXPORT void TFunction_Scope::Restore | ( | const Handle(TDF_Attribute)& | with | ) | `[virtual]`

| Implements TDF_Attribute.

static Standard_EXPORT Handle_TFunction_Scope TFunction_Scope::Set | ( | const TDF_Label & | Access | ) | `[static]`

Standard_EXPORT void TFunction_Scope::SetFreeID | ( | const Standard_Integer | ID | ) |

## Field Documentation

Standard_Integer TFunction_Scope::myFreeID `[private]`

TFunction_DoubleMapOfIntegerLabel TFunction_Scope::myFunctions `[private]`

TFunction_Logbook TFunction_Scope::myLogbook `[private]`

The documentation for this class was generated from the following file:

- TFunction_Scope.hxx